<?php

/**
 * @author Kiritateru, DharmaMedia.
 * @package e-Boekhouden.nl
 * @copyright 2011
 */

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.helper');
jimport('joomla.error.error');

class eBoekhoudenHelperExternal
{
    static $taxCodes = array('LOW' => 'LAAG_VERK', 'HIGH' => 'HOOG_VERK', 'VHIGH' => 'HOOG_VERK_21',
        'ZERO_IN_EU' => 'BI_EU_VERK', 'ZERO_OUT_EU' => 'BU_EU_VERK', 'NONE' => 'GEEN');

    static $euArray = array('AUT', 'AT', 'BEL', 'BE', 'BGR', 'BG', 'CZE', 'CZ',
        'DEU', 'DE', 'DNK', 'DK', 'ESP', 'ES', 'EST', 'EE', 'FRA', 'FR', 'FIN', 'FI',
        'GBR', 'GB', 'GRC', 'GR', 'HUN', 'HU', 'ITA', 'IT', 'IRL', 'IE', 'LUX', 'LU',
        'LVA', 'LV', 'MLT', 'MT', 'MCO', 'MC', 'NLD', 'NL', 'PRT', 'PT', 'POL', 'PL',
        'ROM', 'RO', 'SWE', 'SE', 'SVK', 'SK', 'SVN', 'SI');

    function getTaxes($incl, $excl, $country)
    {
        if (round($incl) == round($excl)) {
            $applied = 0;
            $tax_amount = 0;
        } else {
            // Thanks to Alexander Willemse for this
            $applied = (($incl / $excl) * 100) - 100;
            $tax_amount = round($incl - $excl, 2);
        }

        if ($applied) {
            if (intval($applied) < 12) {
                $code = self::$taxCodes['LOW'];
            } else {
                if(intval($applied) < 20) {
                    $code = self::$taxCodes['HIGH'];
                } else {
                    $code = self::$taxCodes['VHIGH'];
                }
            }
        } else {
            if (in_array(strtoupper($country), self::$euArray)) {
                if (strtoupper($country) != 'NL' && strtoupper($country) != 'NLD') {
                    $params = JComponentHelper::getParams('com_eboekhouden');
                    $c = $params->get('user_field');
                    if (isset($shipping->$c) && $shipping->$c) {
                        //$this->external_data->tax_code = self::$taxCodes['ZERO_IN_EU'];
                        $code = self::$taxCodes['ZERO_IN_EU'];
                    } else {
                        //$this->external_data->tax_code = self::$taxCodes['NONE'];
                        $code = self::$taxCodes['NONE'];
                    }
                } else {
                    $code = self::$taxCodes['NONE'];
                }
            } else {
                $code = self::$taxCodes['ZERO_OUT_EU'];
            }
        }
        return array('inclusive' => $incl, 'exclusive' => $excl, 'applied' => $applied,
            'tax_amount' => $tax_amount, 'code' => $code, 'country' => $country);
    }
    protected function _getInfo()
    {
        $params = JComponentHelper::getParams('com_eboekhouden');

        if (!$params->get('username') || !strlen($params->get('username'))) {
            JError::raiseWarning('001', JText::_('COM_EBOEKHOUDEN_EXTERNAL_NO_USERNAME'));
        }
        if (!$params->get('password') || !strlen($params->get('password'))) {
            JError::raiseWarning('001', JText::_('COM_EBOEKHOUDEN_EXTERNAL_NO_PASSWORD'));
        }
        if (!$params->get('guid') || !strlen($params->get('guid'))) {
            JError::raiseWarning('001', JText::_('COM_EBOEKHOUDEN_EXTERNAL_NO_GUID'));
        }

        return array('AUTH' => array('GEBRUIKERSNAAM' => $params->get('username'),
            'WACHTWOORD' => $params->get('password'), 'GUID' => $params->get('guid')),
            'VERSION' => '1.0', 'SOURCE' => 'VIRTUEMART'); // $params->get('source') // $params->get('version') // MAGENTO
    }
    protected function _buildXML($elements)
    {
        $xml = new XMLWriter();
        $xml->openMemory();
        $xml->setIndent(false);
        $xml->startDocument('1.0', 'UTF-8');
        $xml->startElement('API');

        foreach ($elements as $k => $v) {
            self::_addElements($xml, $k, $v);
        }

        $xml->endElement();
        $xml->endDocument();

        $ret = $xml->outputMemory(true);

        return $ret;
    }
    protected function _addElements(&$resource, $key, $value)
    {
        $xml = new XMLWriter();
        $xml->openMemory();
        $xml->setIndent(false);

        // Safety for non-associative array's
        if (!is_numeric($key)) {
            $xml->startElement($key);
        }

        if (!is_array($value)) {
            $xml->text($value === null ? '' : $value);
        } else {
            foreach ($value as $k => $v) {
                self::_addElements($xml, $k, $v);
            }
        }

        $xml->endElement();
        $resource->writeRaw($xml->outputMemory(true));
    }
    function getLargeNumbersOptions()
    {
        $params = array('ACTION' => 'LIST_GBCODE');
        
        $res = self::_getResponse($params);
        $arr = array();
        
        if (isset($res->RESULT->GBCODES->GBCODE)) {
            foreach ($res->RESULT->GBCODES->GBCODE as $i) {
                array_push($arr, JHtml::_('select.option', $i->CODE, "{$i->CODE} $i->OMSCHRIJVING"));
            }
        }
        
        return $arr;
    }
    function getLargeNumbers($current_selected, $param = false)
    {
        $params = array('ACTION' => 'LIST_GBCODE');

        $res = self::_getResponse($params);

        $name = $param ? "params[$param]" : 'large_number';
    
        $html = '<select name="' . $name . '" id="large_number" >';
        $html .= '<option value="">' . JText::_('EBOEKHOUDEN_NO_LARGE_NUMBER') .
            '</option>';

        if (isset($res->RESULT->GBCODES->GBCODE)) {
            foreach ($res->RESULT->GBCODES->GBCODE as $i) {
                if ($i->CODE == $current_selected) {
                    $html .= '<option value="' . $i->CODE . '" selected="true">' . $i->CODE . ' ' .
                        $i->OMSCHRIJVING . '</option>';
                } else {
                    $html .= '<option value="' . $i->CODE . '">' . $i->CODE . ' ' . $i->
                        OMSCHRIJVING . '</option>';
                }

            }
        }
        $html .= '</select>';
        return $html;
    }
    function exportOrder($order)
    {
        if (!$order->buildExportOrder()) {
            JController::setRedirect('index.php?option=com_eboekhouden&controller=orders');
            JController::redirect();
        }
        
        $res = self::_getResponse($order->getExportOrder());

        if (isset($res->MUTNR)) {
            return (int)$res->MUTNR;
        }

        JError::raiseNotice('005', JText::_('COM_EBOEKHOUDEN_RESPONSE_MUTATION_FAILED'));
        return 0;
    }
    protected function _getResponse($params)
    {
        $str = self::_buildXML(array_merge($params, self::_getInfo()));
        if(JRequest::getVar('conf_debug') && JRequest::getVar('debug_id') == 6) {
            var_dump($str);die();
        }
        if(function_exists('curl_init')) {
            try {
                $ch = curl_init();
                curl_setopt($ch, CURLOPT_URL, 'https://secure.e-Boekhouden.nl/bh/api.asp?xml='.urlencode($str));
                curl_setopt($ch, CURLOPT_HEADER, false);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
                curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);

                @$content = simplexml_load_string(curl_exec($ch));
                curl_close($ch);
            } catch (exception $e) {
                JError::raiseError(JText::_('COM_EBOEKHOUDEN_CONNECTION_ISSUE'));
            }
        } else {
            try {
                @$content = file_get_contents('https://secure.e-Boekhouden.nl/bh/api.asp?xml=' .
                    urlencode($str));
                @$content = simplexml_load_string($content);
            }
            catch (exception $e) {
                JError::raiseError(JText::_('COM_EBOEKHOUDEN_CONNECTION_ISSUE'));
            }
        }

        if (isset($content->ERROR)) {
            JError::raiseNotice('002', $content->ERROR->DESCRIPTION);
        }

        return $content;
    }
    function getExternalQuery($type, $select = '', $where = '', $order = '')
    {
        jimport('joomla.version');
        $version = new JVersion();

        if (!$select) {
            $select = '*';
        }
        $query = 'SELECT ' . $select . ' FROM ';
        if (self::_isVirtuemart()) {
            switch ($type) {
                case 'product':
                    if((float)$version->RELEASE < 1.7) {
                        $query .= '#__vm_product ' . $where . ' ' . $order;
                    } else {
                        $query .= '#__virtuemart_products ' . $where . ' ' . $order;
                    }
                    break;
                case 'order':
                    if((float)$version->RELEASE < 1.7) {
                        $query .= '#__vm_orders ' . $where . ' ' . $order;
                    } else {
                        $query .= '#__virtuemart_orders ' . $where . ' ' . $order;
                    }
                    break;
                case 'order.item':
                    if((float)$version->RELEASE < 1.7) {
                        $query .= '#__vm_order_item ' . $where . ' ' . $order;
                    } else {
                        $query .= '#__virtuemart_order_items ' . $where . ' ' . $order;
                    }
                    break;
                case 'order.shipping':
                    if((float)$version->RELEASE < 1.7) {
                        $query .= '#__vm_order_user_info ' . $where . ' ' . $order;
                    } else {
                        $query .= '#__virtuemart_order_userinfos AS a ' .
                            'LEFT JOIN #__virtuemart_countries AS b ON a.virtuemart_country_id = b.virtuemart_country_id ' . 
                            $where . ' ' . $order;
                    }
                    break;
                case 'category':
                    if((float)$version->RELEASE < 1.7) {
                        $query .= '#__vm_category ' . $where . ' ' . $order;
                    } else {
                        $query .= '#__virtuemart_categories ' . $where . ' ' . $order;
                    }
                    break;
                case 'category.removed':
                    if((float)$version->RELEASE < 1.7) {
                        $query .= '#__eboekhouden_categories AS a ' .
                            'LEFT JOIN #__vm_category AS b ON a.category_id = b.category_id ' .
                            'WHERE b.category_id IS NULL';
                    } else {
                        $query .= '#__eboekhouden_categories AS a ' .
                            'LEFT JOIN #__virtuemart_categories AS b ON a.category_id = b.virtuemart_category_id ' .
                            'WHERE b.virtuemart_category_id IS NULL';
                    }
                    break;
                case 'product.removed':
                    if((float)$version->RELEASE < 1.7) {
                        $query .= '#__eboekhouden_products AS a ' .
                            'LEFT JOIN #__vm_product AS b ON a.product_id = b.product_id ' .
                            'WHERE b.product_id IS NULL';
                    } else {
                        $query .= '#__eboekhouden_products AS a ' .
                                'LEFT JOIN #__virtuemart_products AS b ON a.product_id = b.virtuemart_product_id ' .
                                'WHERE b.virtuemart_product_id IS NULL';
                    }
                    break;
                case 'order.removed':
                    if((float)$version->RELEASE < 1.7) {
                        $query .= '#__eboekhouden_orders AS a ' .
                            'LEFT JOIN #__vm_orders AS b ON a.order_id = b.order_id ' .
                            'WHERE b.order_id IS NULL';
                    } else {
                        $query .= '#__eboekhouden_orders AS a ' .
                            'LEFT JOIN #__virtuemart_orders AS b ON a.order_id = b.virtuemart_order_id ' .
                            'WHERE b.virtuemart_order_id IS NULL';
                    }
                    break;
            }
        }

        return $query;
    }
    function getQuery($type, $select = '', $where = '')
    {
        jimport('joomla.version');
        $version = new JVersion();
        
        if (!$select) {
            $select = '*';
        }
        $query = 'SELECT ' . $select . ' FROM ';
        if((float)$version->RELEASE > 1.5) {
            require_once implode(DS, array(JPATH_ADMINISTRATOR, 'components', 'com_virtuemart', 'helpers', 'config.php'));
            VmConfig::loadConfig();
            $lang = VmConfig::setdbLanguageTag();
        }
        
        if (self::_isVirtuemart()) {
            switch ($type) {
                case 'product':
                    if((float)$version->RELEASE < 1.7) {
                        $query .= '#__eboekhouden_products AS a ' .
                            'LEFT JOIN #__vm_product AS b ON a.product_id = b.product_id ' .
                            'LEFT JOIN #__vm_product_category_xref AS c ON b.product_id = c.product_id ' .
                            'LEFT JOIN #__vm_category AS d ON c.category_id = d.category_id ' . $where;
                    } else {
                        $query .= '#__eboekhouden_products AS a ' .
                            'LEFT JOIN #__virtuemart_products AS b ON a.product_id=b.virtuemart_product_id ' .
                            'LEFT JOIN #__virtuemart_product_categories AS c ON b.virtuemart_product_id=c.virtuemart_product_id ' .
                            'LEFT JOIN #__virtuemart_categories AS d ON c.virtuemart_category_id=d.virtuemart_category_id ' . 
                            'LEFT JOIN #__virtuemart_products_'.$lang.' AS e ON b.virtuemart_product_id=e.virtuemart_product_id ' . 
                            'LEFT JOIN #__virtuemart_categories_'.$lang.' AS f ON f.virtuemart_category_id=d.virtuemart_category_id ' . $where;
                    }
                    break;
                case 'products':
                        $query .= '#__eboekhouden_products ' . $where;
                break;
                case 'category':
                    if((float)$version->RELEASE < 1.7) {
                        $query .= '#__eboekhouden_categories AS a ' .
                            'LEFT JOIN #__vm_category AS b ON a.category_id=b.category_id ' . $where;
                    } else {
                        $query .= '#__eboekhouden_categories AS a ' .
                            'LEFT JOIN #__virtuemart_categories AS b ON a.category_id=b.virtuemart_category_id ' . 
                            'LEFT JOIN #__virtuemart_categories_'.$lang.' AS f ON f.virtuemart_category_id=b.virtuemart_category_id ' .
                            'LEFT JOIN #__virtuemart_category_categories AS g ON b.virtuemart_category_id=g.category_child_id ' . $where;
                    }
                    break;
                case 'categories':
                        $query .= '#__eboekhouden_categories ' . $where;
                break;
                case 'order':
                    if((float)$version->RELEASE < 1.7) {
                        $query .= '#__eboekhouden_orders AS a ' .
                            'LEFT JOIN #__vm_orders AS b ON a.order_id=b.order_id ' .
                            'LEFT JOIN #__vm_user_info AS c ON b.user_id =c.user_id ' .
                            'LEFT JOIN #__vm_order_item AS d ON a.order_id=d.order_id ' .
                            'LEFT JOIN #__vm_order_status AS e ON b.order_status=e.order_status_code ' . $where;
                    } else {
                        $query .= '#__eboekhouden_orders AS a ' .
                            'LEFT JOIN #__virtuemart_orders AS b ON a.order_id=b.virtuemart_order_id ' .
                            'LEFT JOIN #__virtuemart_order_userinfos AS c ON b.virtuemart_user_id=c.virtuemart_user_id AND b.virtuemart_order_id=c.virtuemart_order_id ' .
                            'LEFT JOIN #__virtuemart_order_items AS d ON a.order_id=d.virtuemart_order_id ' .
                            'LEFT JOIN #__virtuemart_orderstates AS e ON b.order_status=e.order_status_code ' . $where . ' GROUP BY a.id';
                    }
                    break;
                case 'category.product.large_number':
                    if((float)$version->RELEASE < 1.7) {
                        $query .= '#__vm_product_category_xref AS a ' .
                            'LEFT JOIN #__eboekhouden_categories AS b ON b.category_id=a.category_id WHERE a.product_id= ' .
                            $where;
                    } else {
                        $query .= '#__virtuemart_product_categories AS a ' .
                            'LEFT JOIN #__eboekhouden_categories AS b ON b.category_id=a.virtuemart_category_id WHERE a.virtuemart_product_id= ' .
                            $where;
                    }
                    break;
                case 'products.parents':
                    if((float)$version->RELEASE < 1.7) {
                        return self::getQuery('product', $select, $where);
                    } else {
                        $query = 'SELECT a.virtuemart_product_id, a.product_parent_id, b.virtuemart_category_id ' .
                            'FROM #__virtuemart_products AS a ' .
                            'LEFT JOIN #__virtuemart_product_categories AS b ON b.virtuemart_product_id=a.virtuemart_product_id ';
                    }
                    break;
                case 'categories.parents':
                    if((float)$version->RELEASE < 1.7) {
                        return self::getQuery('category', $select, $where);
                    } else {
                        $query = 'SELECT a.virtuemart_category_id, b.category_parent_id ' .
                            'FROM #__virtuemart_categories AS a ' .
                            'LEFT JOIN #__virtuemart_category_categories AS b ON b.category_child_id=a.virtuemart_category_id ';
                    }
                break;
            }
        }

        return $query;
    }
    function _isVirtuemart()
    {
        return JComponentHelper::getComponent('com_virtuemart', true)->enabled;
    }
    function _isRedShop()
    {
        return JComponentHelper::getComponent('com_redshop', true)->enabled;
    }
}
