<?php

/**
 * @author Kiritateru, DharmaMedia.
 * @package e-Boekhouden.nl
 * @copyright 2011
 */

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class eBoekhoudenModelCategory extends JModel
{
	var $_total = null;
	var $_pagination = null;

	function __construct()
	{
		parent::__construct();
		global $mainframe, $option;

		//$limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		//$limitstart = JRequest::getVar('limitstart', 0, '', 'int');

		//$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

		//$this->setState('limit', $limit);
		//$this->setState('limitstart', $limitstart);
	}

	function setId($id)
	{
		$this->_id		= $id;
		$this->_data	= null;
	}


	function getList( $filters )
	{
		$db			= &$this->getDBO();
		$ordering	= isset($filters['ordering']) ? $filters['ordering'] : '';

		$wheres = array();
		
		if (isset($filters['cid']))
		{
			$wheres[] = 'cid = ' . (int) $filters['cid'];
		} else if(isset($filters['category_id']))	{
			$wheres[] = 'category_id = ' . (int) $filters['category_id'];
		} else if(isset($filters['tax_group_id'])) {
			$wheres[] = 'tax_group_id = ' . (int) $filters['tax_group_id'];
		} else if(isset($filters['large_number'])) {
			$wheres[] = 'large_number = ' . (int) $filters['large_number'];
		}

		$query = "SELECT *"
			. ' FROM #__eboekhouden_categories'
			. ' WHERE ' . implode( ' AND ', $wheres )
            . ' ORDER BY ' . $ordering;

		$db->setQuery( $query, 0, $filters['limit'] );

		return $db->loadObjectList();
	}

	function getTotal()
	{
		if (empty($this->_total))
		{
			$query = $this->_buildQuery();
			$this->_total = $this->_getListCount($query);
		}

		return $this->_total;
	}

	function getPagination()
	{
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}

		return $this->_pagination;
	}

	function _buildQuery()
	{
		return 'SELECT *' .
			' FROM #__eboekhouden_categories';

	}
    function &loadData($key = '', $value = '')
    {
	   if(!$key || !$value) {
	       $key = 'id';
           $value = isset($this->_id) ? $this->_id : 0;
	   }
		// Load the data
		if (empty( $this->_data )) {
			$query = ' SELECT * FROM #__eboekhouden_categories'.
					'  WHERE ' . $key . ' = '.$value;
			$this->_db->setQuery( $query );
			$this->_data = $this->_db->loadObject();
            if($this->_data && isset($this->_data->id)) {
                $this->_id = $this->_data->id;    
            }
		}
		return $this->_data;        
    }
	function &getData($list = true)
	{ 
       
		if (empty($this->_data)) {
			$query = $this->_buildQuery();
            if($list) {
                $this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));    
            } else {
    			$query = ' SELECT * FROM #__eboekhouden_categories'.
    					'  WHERE id = ' . ($this->_id);
    			$this->_db->setQuery( $query );
    			$this->_data = $this->_db->loadObject();                
            }
		}
		return $this->_data;
	}

	function store($data = false)
	{
		$row = &$this->getTable('category', 'eboekhoudenTable');
		if(!$data) {
			$data = JRequest::get( 'post' );
		}
        
        if(is_object($data)) {
            if(!isset($data->category_id) && isset($data->virtuemart_category_id)) {
                $data->category_id = $data->virtuemart_category_id;
            }
        } elseif(is_array($data)) {
            if(!isset($data['category_id']) && isset($data['virtuemart_category_id'])) {
                $data['category_id'] = $data['virtuemart_category_id'];
            }
        }
        
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		if (!$row->check()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		if (!$row->store()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		return true;
	}

	function delete()
	{
		$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );

		$row =& $this->getTable('Category', 'eBoekhoudenTable');

		if (count( $cids ) && $cids[0]) {
			foreach($cids as $cid) {
				if (!$row->delete( $cid )) {
					$this->setError( $row->getErrorMsg() );
					return false;
				}
			}
		} else {
			if (!$row->delete( isset($this->_id) ? $this->_id : 0 )) {
				$this->setError( $row->getErrorMsg() );
				return false;
			}
		}
		return true;
	}
}