<?php

/**
 * @author Kiritateru, DharmaMedia.
 * @package e-Boekhouden.nl
 * @copyright 2011
 */

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.application.component.helper');
jimport('joomla.error.error');

class eBoekhoudenModelProducts extends JModel
{
    /** These are states inside the EU - VM codes
     * Austria - AUT / AT 
     * Belgium - BEL / BE
     * Bulgaria - BGR / BG 
     * Czech Republic - CZE / CZ
     * Germany - DEU / DE
     * Denmark - DNK / DK
     * Spain - ESP / ES
     * Estonia - EST / EE
     * France - FRA / FR
     * Finland - FIN / FI
     * United Kingdom - GBR / GB
     * Greece - GRC / GR
     * Hongary - HUN / HU
     * Italy - ITA / IT
     * Ireland - IRL /IE
     * Luxembourg - LUX / LU
     * Latvia - LVA / LV
     * Malta - MLT / MT
     * Monaco - MCO / MC
     * Netherlands - NLD / NL
     * Portugal - PRT / PT
     * Poland - POL / PL
     * Romania - ROM / RO
     * Sweden - SWE / SE
     * Slowakije - SVK / SK
     * Slovenia - SVN / SI
     **/
    var $_euArray = array('AUT', 'AT', 'BEL', 'BE', 'BGR', 'BG', 'CZE', 'CZ', 'DEU', 'DE', 'DNK', 'DK', 'ESP', 'ES', 'EST',
        'EE', 'FRA', 'FR', 'FIN', 'FI', 'GBR', 'GB', 'GRC', 'GR', 'HUN', 'HU', 'ITA', 'IT', 'IRL', 'IE', 'LUX', 'LU', 'LVA', 'LV', 'MLT',
        'MT', 'MCO', 'MC', 'NLD', 'NL', 'PRT', 'PT', 'POL', 'PL', 'ROM', 'RO', 'SWE', 'SE', 'SVK', 'SK', 'SVN', 'SI');
        

    function __construct()
    {
        parent::__construct();

        $array = JRequest::getVar('cid', 0, '', 'array');
        $this->setId((int)$array[0]);
    }
    function getTaxes($order_id)
    {
        if (empty($this->_data) && $this->_id) {
            $this->getData();
        }

        $q = eBoekhoudenHelperExternal::getExternalQuery('order.item',
            'product_item_price AS excl, product_final_price AS incl, product_quantity AS quantity',
            'WHERE virtuemart_order_id=' . $order_id . ' AND virtuemart_product_id=' . $this->_data->product_id);

        $this->_db->setQuery($q);
        $this->_db->query();
        $this->external_data = $this->_db->loadObject();
        
        $q = eBoekhoudenHelperExternal::getExternalQuery('order.shipping', '',
                'WHERE a.virtuemart_order_id=' . $order_id);
        $this->_db->setQuery($q);
        $this->_db->query();
        
        $shipping = $this->_db->loadObject();     
        $country = $shipping->country_3_code;
        
        $taxArray = eBoekhoudenHelperExternal::getTaxes($this->external_data->incl, $this->
            external_data->excl, $country);
        
        $this->external_data->applied_tax = $taxArray['applied'];
        $this->external_data->tax_amount = $taxArray['tax_amount'];
        $this->external_data->tax_code = $taxArray['code'];
        
        /*
        // Thanks to Alexander Willemse for this
        if ($this->external_data->incl == $this->external_data->excl || !$this->
            external_data->excl || !$this->external_data->incl) {
            $this->external_data->applied_tax = "0";
            $this->external_data->tax_amount = "0";
        } else {
            $this->external_data->applied_tax = (($this->external_data->incl / $this->
                external_data->excl) * 100) - 100;
            $this->external_data->tax_amount = round($this->external_data->incl - $this->
                external_data->excl, 2);
        }

        if ($this->external_data->applied_tax) {
            if (intval($this->external_data->applied_tax) < 12) {
                $this->external_data->tax_code = eBoekhoudenHelperExternal::$taxCodes['LOW']; // $this->_taxCodes['LOW'];
            } else {
                $this->external_data->tax_code = eBoekhoudenHelperExternal::$taxCodes['HIGH']; // $this->_taxCodes['HIGH']; //"HOOG_VERK";
            }
        } else {
            $q = eBoekhoudenHelperExternal::getExternalQuery('order.shipping', '',
                'WHERE order_id=' . $order_id);
            $this->_db->setQuery($q);
            $this->_db->query();
            $shipping = $this->_db->loadObject();

            $country = $shipping->country;

            if (in_array(strtoupper($country), $this->_euArray)) {
                if (strtoupper($country) != 'NL' && strtoupper($country) != 'NLD') {
                    $params = JComponentHelper::getParams('com_eboekhouden');
                    $c = $params->get('user_field');
                    if (isset($shipping->$c) && $shipping->$c) {
                        $this->external_data->tax_code = eBoekhoudenHelperExternal::$taxCodes['ZERO_IN_EU']; //$this->_taxCodes['ZERO_IN_EU']; //"BI_EU_VERK";
                    } else {
                        $this->external_data->tax_code = eBoekhoudenHelperExternal::$taxCodes['NONE']; //$this->_taxCodes['NONE']; //"GEEN";
                    }
                } else {
                    $this->external_data->tax_code = eBoekhoudenHelperExternal::$taxCodes['NONE']; //$this->_taxCodes['NONE']; //"GEEN";
                }
            } else {
                $this->external_data->tax_code = eBoekhoudenHelperExternal::$taxCodes['ZERO_OUT_EU']; //$this->_taxCodes['ZERO_OUT_EU']; //'BU_EU_VERK';
            }
        }        
        */
        return $this->external_data;
    }
    function getLargeNumber()
    {
        if (empty($this->_data) && $this->_id) {
            $this->getData();
        }
        
        if ($this->_data->large_number) {
            return $this->_data->large_number;
        }
        
        $q = eBoekhoudenHelperExternal::getQuery('category.product.large_number', '', $this->_data->
            product_id);
        $this->_db->setQuery($q);
        $ln = $this->_db->loadObject();
        
        if ($ln && isset($ln->large_number)) {
            $this->_data->large_number = $ln->large_number;
        } else {
            // list of products from virtuemart
            $q = eBoekhoudenHelperExternal::getQuery('products.parents', '', '');
            $this->_db->setQuery($q);
            $va = $this->_db->loadObjectList();
            // list of products that might have a large_number
            $q = eBoekhoudenHelperExternal::getQuery('products');
            $this->_db->setQuery($q);
            $vb = $this->_db->loadObjectList();
            
            $id = $this->_data->product_id;
            $cat = false;
            
            do {
                $obj1 = $this->traverse('virtuemart_product_id', $id, $va);
                $obj2 = $this->traverse('product_id', $id, $vb);
                
                if($cat === false && $obj1->virtuemart_category_id) {
                    // use the first category we can find
                    $cat = $obj1->virtuemart_category_id;
                }
                if($obj2->large_number) {
                    $this->_data->large_number = $obj2->large_number;
                    return $this->_data->large_number;
                }
                $id = $obj1->product_parent_id;
            } while(!$this->_data->large_number && $id);
            
            // Didn't find anything, search categories if any
            if($cat) {
                // list of categories from virtuemart
                $q = eBoekhoudenHelperExternal::getQuery('categories.parents', '', '');
                $this->_db->setQuery($q);
                $va = $this->_db->loadObjectList();
                // list of categories that might have a large_number
                $q = eBoekhoudenHelperExternal::getQuery('categories');
                $this->_db->setQuery($q);
                $vb = $this->_db->loadObjectList();
                
                do {
                    $obj1 = $this->traverse('virtuemart_category_id', $cat, $va);
                    $obj2 = $this->traverse('category_id', $cat, $vb);
                    
                    if($obj2->large_number) {
                        $this->_data->large_number = $obj2->large_number;
                        return $this->_data->large_number;
                    }
                    $cat = $obj1->category_parent_id;
                } while(!$this->_data->large_number && $cat);
            
            }
            
            JError::raiseNotice('004', JText::sprintf('COM_EBOEKHOUDEN_EXPORT_NO_LARGE_NUMBER', $this->
                _id));
        }

        return $this->_data->large_number;
    }
    function traverse($key, $val, &$arr) {
        foreach($arr as $i) {
            if(!isset($i->$key)) {
                continue;
            }
            if($i->$key == $val) {
                return $i;
            }
        }
        return false;
    }
    function setId($id)
    {
        $this->_id = $id;
        $this->_data = null;
    }

    function &getData($key = false, $value = false)
    {
        if (empty($this->_data)) {
            if (!$key || !$value) {
                $key = 'id';
                $value = $this->_id;
            }
            $query = ' SELECT * FROM #__eboekhouden_products' . '  WHERE ' . $key . ' = ' .
                $value;
                
            $this->_db->setQuery($query);
            $this->_data = $this->_db->loadObject();
            if($this->_data && isset($this->_data->id)) {
                $this->_id = $this->_data->id;    
            }
        }
        return $this->_data;
    }

    function store($data = false)
    {
        $row = &$this->getTable('products', 'eBoekhoudenTable');

        if (!$data) {
            $data = JRequest::get('post');
        }
        if(is_object($data)) {
            if(!isset($data->product_id) && isset($data->virtuemart_product_id)) {
                $data->product_id = $data->virtuemart_product_id;
            }
        } elseif(is_array($data)) {
            if(!isset($data['product_id']) && isset($data['virtuemart_product_id'])) {
                $data['product_id'] = $data['virtuemart_product_id'];
            }
        }

        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        if (!$row->store()) {
            $this->setError($row->getErrorMsg());
            return false;
        }

        return true;
    }

    function delete()
    {
        $cids = JRequest::getVar('cid', array(0), 'post', 'array');

        $row = &$this->getTable('Products', 'eBoekhoudenTable');

        if (count($cids) && $cids[0]) {
            foreach ($cids as $cid) {
                if (!$row->delete($cid)) {
                    $this->setError($row->getErrorMsg());
                    return false;
                }
            }
        } else {
            if (!$row->delete($this->_id)) {
                $this->setError($row->getErrorMsg());
                return false;
            }
        }
        return true;
    }

}
